{
TGMMap component

  ES: componente para usar el mapa de Google Maps
  EN: component to use the Google Maps map

=========================================================================
MODO DE USO/HOW TO USE

  ES: poner el componente en el formulario, linkarlo a un TWebBrowser,
      Activarlo y ejecutar el mtodo DoMap
  EN: put the component into a form, link to a TWebBrowser, put Active and
      call DoMap method
=========================================================================
History:

ver 0.1:
  ES: primera versin
  EN: first version
=========================================================================
ES: IMPORTANTE PROGRAMADORES: Por favor, si tienes comentarios, mejoras,
  ampliaciones, errores y/o cualquier otro tipo de sugerencia, envame un correo a:
  gmlib@cadetill.com

EN: IMPORTANT PROGRAMMERS: please, if you have comments, improvements, enlargements,
  errors and/or any another type of suggestion, please send me a mail to:
  gmlib@cadetill.com
=========================================================================

Copyright () 2012, by Xavier Martinez (cadetill)

@author Xavier Martinez (cadetill)
@web  http://www.cadetill.com
}
unit GMMap;

interface

uses
  Classes, ExtCtrls, SHDocVw, Graphics,
  GMBase, Constants, GMLatLng, GMLatLngBounds, GMBaseInfoWindow;

type
  TEventsForm = record
      // map
    BoundsChanged: Boolean;
    CenterChanged: Boolean;
    Click: Boolean;
    DblClick: Boolean;
    Drag: Boolean;
    DragEnd: Boolean;
    DragStart: Boolean;
    MapTypeIdChanged: Boolean;
    MouseMove: Boolean;
    MouseOut: Boolean;
    MouseOver: Boolean;
    RightClick: Boolean;
    TilesLoaded: Boolean;
    ZoomChanged: Boolean;
    SWLat: Real;
    SWLng: Real;
    NELat: Real;
    NELng: Real;
    Lat: Real;
    Lng: Real;
    MapTypeId: string;
    Zoom: Integer;
      // general
    LinkCompId: Integer;
    LinkCompZIndex: Integer;
      // marker
    MarkerClick: Boolean;
    MarkerDblClick: Boolean;
    MarkerDrag: Boolean;
    MarkerDragEnd: Boolean;
    MarkerDragStart: Boolean;
    MarkerMouseDown: Boolean;
    MarkerMouseOut: Boolean;
    MarkerMouseOver: Boolean;
    MarkerMouseUp: Boolean;
    MarkerRightClick: Boolean;
    MarkerLat: Real;
    MarkerLng: Real;
      // InfoWindow
    InfoWinId: Integer;
    InfoWinZIndex: Integer;
    InfoWinCloseClick: Boolean;
  end;

  TGMLinkedComponent = class;

  TMapTypeIds = set of TMapTypeId;

  { ****************************************************************************
    https://developers.google.com/maps/documentation/javascript/reference#MapTypeControlOptions
  **************************************************************************** }
  TMapTypeControlOptions = class(TPersistent)
  private
    FPosition: TControlPosition;
    FStyle: TMapTypeControlStyle;
    FMapTypeIds: TMapTypeIds;
    FShow: Boolean;
  public
    constructor Create; virtual;

    procedure Assign(Source: TPersistent); override;
  published
    property MapTypeIds: TMapTypeIds read FMapTypeIds write FMapTypeIds default [mtHYBRID, mtROADMAP, mtSATELLITE, mtTERRAIN]; // mapTypeIds
    property Position: TControlPosition read FPosition write FPosition;   // position
    property Style: TMapTypeControlStyle read FStyle write FStyle; // style
    property Show: Boolean read FShow write FShow;
  end;

  { ****************************************************************************
    https://developers.google.com/maps/documentation/javascript/reference#OverviewMapControlOptions
  **************************************************************************** }
  TOverviewMapControlOptions = class(TPersistent)
  private
    FOpened: Boolean;
    FShow: Boolean;
  public
    constructor Create; virtual;

    procedure Assign(Source: TPersistent); override;
  published
    property Opened: Boolean read FOpened write FOpened;  // opened
    property Show: Boolean read FShow write FShow;
  end;

  { ****************************************************************************
    https://developers.google.com/maps/documentation/javascript/reference#PanControlOptions
  **************************************************************************** }
  TPanControlOptions = class(TPersistent)
  private
    FPosition: TControlPosition;
    FShow: Boolean;
  public
    constructor Create; virtual;

    procedure Assign(Source: TPersistent); override;
  published
    property Position: TControlPosition read FPosition write FPosition;   // position
    property Show: Boolean read FShow write FShow;
  end;

  { ****************************************************************************
    https://developers.google.com/maps/documentation/javascript/reference#RotateControlOptions
  **************************************************************************** }
  TRotateControlOptions = class(TPersistent)
  private
    FPosition: TControlPosition;
    FShow: Boolean;
  public
    constructor Create; virtual;

    procedure Assign(Source: TPersistent); override;
  published
    property Position: TControlPosition read FPosition write FPosition;   // position
    property Show: Boolean read FShow write FShow;
  end;

  { ****************************************************************************
    https://developers.google.com/maps/documentation/javascript/reference#ScaleControlOptions
  **************************************************************************** }
  TScaleControlOptions = class(TPersistent)
  private
    FPosition: TControlPosition;
    FStyle: TScaleControlStyle;
    FShow: Boolean;
  public
    constructor Create; virtual;

    procedure Assign(Source: TPersistent); override;
  published
    property Position: TControlPosition read FPosition write FPosition;   // position
    property Style: TScaleControlStyle read FStyle write FStyle;  // style
    property Show: Boolean read FShow write FShow;
  end;

  { ****************************************************************************
    https://developers.google.com/maps/documentation/javascript/reference#StreetViewControlOptions
  **************************************************************************** }
  TStreetViewControlOptions = class(TPersistent)
  private
    FPosition: TControlPosition;
    FShow: Boolean;
  public
    constructor Create; virtual;

    procedure Assign(Source: TPersistent); override;
  published
    property Position: TControlPosition read FPosition write FPosition;   // position
    property Show: Boolean read FShow write FShow;
  end;

  { ****************************************************************************
    https://developers.google.com/maps/documentation/javascript/reference#ZoomControlOptions
  **************************************************************************** }
  TZoomControlOptions = class(TPersistent)
  private
    FPosition: TControlPosition;
    FStyle: TZoomControlStyle;
    FShow: Boolean;
  public
    constructor Create; virtual;

    procedure Assign(Source: TPersistent); override;
  published
    property Position: TControlPosition read FPosition write FPosition;   // position
    property Style: TZoomControlStyle read FStyle write FStyle;  // style
    property Show: Boolean read FShow write FShow;
  end;

  { ****************************************************************************
    internal class
  **************************************************************************** }
  TVisualProp = class(TPersistent)
  private
    FMapTypeCtrl: TMapTypeControlOptions;
    FOverviewMapCtrl: TOverviewMapControlOptions;
    FPanCtrl: TPanControlOptions;
    FRotateCtrl: TRotateControlOptions;
    FScaleCtrl: TScaleControlOptions;
    FStreetViewCtrl: TStreetViewControlOptions;
    FZoomCtrl: TZoomControlOptions;
    FBGColor: TColor;
  public
    constructor Create; virtual;
    destructor Destroy; override;

    procedure Assign(Source: TPersistent); override;
  published
    property BGColor: TColor read FBGColor write FBGColor;    // backgroundColor
    property MapTypeCtrl: TMapTypeControlOptions read FMapTypeCtrl write FMapTypeCtrl;
    property OverviewMapCtrl: TOverviewMapControlOptions read FOverviewMapCtrl write FOverviewMapCtrl;
    property PanCtrl: TPanControlOptions read FPanCtrl write FPanCtrl;
    property RotateCtrl: TRotateControlOptions read FRotateCtrl write FRotateCtrl;
    property ScaleCtrl: TScaleControlOptions read FScaleCtrl write FScaleCtrl;
    property StreetViewCtrl: TStreetViewControlOptions read FStreetViewCtrl write FStreetViewCtrl;
    property ZoomCtrl: TZoomControlOptions read FZoomCtrl write FZoomCtrl;
  end;

  TBoolOption = (DisableDoubleClickZoom, Draggable, KeyboardShortcuts, NoClear, ScrollWheel);
  TBoolOptions = set of TBoolOption;
  { ****************************************************************************
    internal class
  **************************************************************************** }
  TNonVisualProp = class(TPersistent)
  private
    FOptions: TBoolOptions;
    FMinZoom: Integer;
    FMaxZoom: Integer;
    procedure SetMaxZoom(const Value: Integer);
    procedure SetMinZoom(const Value: Integer);
  public
    constructor Create; virtual;

    procedure Assign(Source: TPersistent); override;
  published
    property Options: TBoolOptions read FOptions write FOptions default [Draggable, KeyboardShortcuts, ScrollWheel];
    property MaxZoom: Integer read FMaxZoom write SetMaxZoom;   // maxZoom, 0 = null
    property MinZoom: Integer read FMinZoom write SetMinZoom;   // minZoom, 0 = null
  end;

  { ****************************************************************************
    internal class
  **************************************************************************** }
  TRequiredProp = class(TPersistent)
  private
    FCenter: TLatLng;
    FZoom: Integer;
    FMapType: TMapTypeId;
  public
    constructor Create; virtual;
    destructor Destroy; override;

    procedure Assign(Source: TPersistent); override;
  published
    property Center: TLatLng read FCenter write FCenter;       // center
    property MapType: TMapTypeId read FMapType write FMapType; // mapTypeId
    property Zoom: Integer read FZoom write FZoom;             // zoom
  end;

  TAfterPageLoaded = procedure(Sender: TObject; First: Boolean) of object;
  TBoundsChanged = procedure(Sender: TObject; NewBounds: TLatLngBounds) of object;
  TLatLngEvent = procedure(Sender: TObject; LatLng: TLatLng) of object;
  TMapTypeIdChanged = procedure(Sender: TObject; NewMapTypeId: TMapTypeId) of object;
  TZoomChanged = procedure(Sender: TObject; NewZoom: Integer) of object;

  { ****************************************************************************
    https://developers.google.com/maps/documentation/javascript/reference#Map
  **************************************************************************** }
  TGMMap = class(TGMBase)
  private
    // internal variables
    FTimer: TTimer;          // ES: TTimer para el control de eventos - EN: TTimer for events control
    CurDispatch: IDispatch;  // ES: variable para el control de la carga de la pgina web - EN: variable for control of load web page
    FDocLoaded: Boolean;     // ES: indica si la pgina web se ha cargado completamente - EN: indicates if the Web page is fully loaded
    OldBeforeNavigate2: TWebBrowserBeforeNavigate2;     // ES: evento de TWebBrowser - EN: event of TWebBrowser
    OldDocumentComplete: TWebBrowserDocumentComplete;   // ES: evento de TWebBrowser - EN: event of TWebBrowser
    OldNavigateComplete2: TWebBrowserNavigateComplete2; // ES: evento de TWebBrowser - EN: event of TWebBrowser
    FLinkedComponents: TList;   // ES: lista de componentes unidos al mapa - EN: list of components linked to map
    FCountLinkedCom: Cardinal;  // ES: contador de componentes que estn unidos (o se unieron) al mapa
                                // EN: count components are linked (or have linked) to map

    // from propertis
    FIntervalEvents: Integer;
    FWebBrowser: TWebBrowser;
    FActive: Boolean;
    FAfterPageLoaded: TAfterPageLoaded;
    FRequiredProp: TRequiredProp;
    FVisualProp: TVisualProp;
    FNonVisualProp: TNonVisualProp;
    FOnBoundsChanged: TBoundsChanged;
    FPrecision: Integer;
    FOnCenterChanged: TLatLngEvent;
    FOnClick: TLatLngEvent;
    FOnDblClick: TLatLngEvent;
    FOnDrag: TNotifyEvent;
    FOnDragStart: TNotifyEvent;
    FOnDragEnd: TNotifyEvent;
    FOnMapTypeIdChanged: TMapTypeIdChanged;
    FOnMouseMove: TLatLngEvent;
    FOnMouseOut: TLatLngEvent;
    FOnMouseOver: TLatLngEvent;
    FOnRightClick: TLatLngEvent;
    FOnZoomChanged: TZoomChanged;

    // ES: eventos del TWebBrowser para el control de la carga de la pgina
    // EN: events of TWebBrowser to control the load page
    {$IF CompilerVersion < 22}  // ES: si la versin es inferior a la XE2 - EN: if the version lower than the XE2
    procedure BeforeNavigate2(ASender: TObject; const pDisp: IDispatch;
      var URL, Flags, TargetFrameName, PostData, Headers: OleVariant;
      var Cancel: WordBool);
    procedure DocumentComplete(ASender: TObject; const pDisp: IDispatch;
      var URL: OleVariant);
    procedure NavigateComplete2(ASender: TObject; const pDisp: IDispatch;
      var URL: OleVariant);
    {$ELSE}                     // ES: si la verisn es la XE2 o superior - EN: if version is XE2 or higher
    procedure BeforeNavigate2(ASender: TObject; const pDisp: IDispatch;
      const URL, Flags, TargetFrameName, PostData, Headers: OleVariant;
      var Cancel: WordBool);
    procedure DocumentComplete(ASender: TObject; const pDisp: IDispatch;
      const URL: OleVariant);
    procedure NavigateComplete2(ASender: TObject; const pDisp: IDispatch;
      const URL: OleVariant);
    {$IFEND}

    function GetBaseHTMLCode: string;

    function AddLinkedComponent(LinkedComponent: TGMLinkedComponent): Integer;
    procedure RemoveLinkedComponent(LinkedComponent: TGMLinkedComponent);

    // ES: ejecuta la funcin JavaScript con los parmetros dados
    // EN: execute a function JavaScript with params
    function ExecuteScript(NameFunct, Params: string): Boolean;
    function ExistLinkedComponent(Id: Cardinal): Integer;

    procedure SetActive(const Value: Boolean);
    procedure SetIntervalEvents(const Value: Integer);
    procedure SetWebBrowser(const Value: TWebBrowser);
    procedure SetPrecision(const Value: Integer);
  protected
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;

    function GetAPIUrl: string; override;

    // ES: funciones de control
    // EN: control functions
    function Check: Boolean;
    function MapIsNull: Boolean;

    // ES: evento OnTimer que se le asignar al TTimer
    // EN: event OnTimer that will be assigned to TTimer
    procedure OnTimer(Sender: TObject); virtual;
    // ES: procedimiento que carga el cdigo base de la pgina web
    // EN: procedure that load the base code of the web page
    procedure LoadBaseWeb;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    procedure Assign(Source: TPersistent); override;

    // ES: conversiones
    // EN: conversions
    function MapTypeIdToStr(MapTypeId: TMapTypeId): string;
    function StrToMapTypeId(MapTypeId: string): TMapTypeId;
    function TColorToStr(Color: TColor): string;
    function MapTypeIdsToStr(Delimiter: Char = ';'): string;
    function PositionToStr(Position: TControlPosition): string;
    function StrToPosition(Position: string): TControlPosition;
    function MapTypeControlStyleToStr(MapTypeControlStyle: TMapTypeControlStyle): string;
    function StrToMapTypeControlStyle(MapTypeControlStyle: string): TMapTypeControlStyle;
    function ScaleControlStyleToStr(ScaleControlStyle: TScaleControlStyle): string;
    function StrToScaleControlStyle(ScaleControlStyle: string): TScaleControlStyle;
    function ZoomControlStyleToStr(ZoomControlStyle: TZoomControlStyle): string;
    function StrToZoomControlStyle(ZoomControlStyle: string): TZoomControlStyle;

    // ES: funciones para la clase LatLngBounds
    // EN: functions for LatLngBounds class
    procedure LatLngBoundsSetBounds(SWLat, SWLng, NELat, NELng: Real); overload;
    procedure LatLngBoundsSetBounds(Bounds: TLatLngBounds); overload;
    function LatLngBoundsGetBounds: TLatLngBounds;
    function LatLngBoundsContains(LatLng: TLatLng): Boolean; overload;
    function LatLngBoundsContains(Lat, Lng: Real): Boolean; overload;
    function LatLngBoundsExtend(LatLng: TLatLng): TLatLngBounds; overload;
    function LatLngBoundsExtend(Lat, Lng: Real): TLatLngBounds; overload;
    function LatLngBoundsGetCenter: TLatLng;
    function LatLngBoundsToSpan: TLatLng;

    // ES: funciones para la clase Map
    // EN: function fot Map class
    function GetCenter: TLatLng;
    function GetMapTypeId: TMapTypeId;
    function GetZoom: Integer;
    procedure PanBy(x, y: Integer);
    procedure PanTo(LatLng: TLatLng); overload;
    procedure PanTo(const Lat, Lng: Real); overload;
    procedure SetCenter(LatLng: TLatLng); overload;
    procedure SetCenter(const Lat, Lng: Real); overload;
    procedure SetMapTypeId(MapTypeId: TMapTypeId); overload;
    procedure SetMapTypeId(const MapTypeId: string); overload;
    procedure SetZoom(Zoom: Integer);

    // ES: crea el mapa con las opciones especificadas
    // EN: create the map with the specified options
    procedure DoMap; virtual;
  published
    // ES: objeto TWebBrowser donde se mostrar la pgina
    // EN: TWebBrowser objetc where show the page
    property WebBrowser: TWebBrowser read FWebBrowser write SetWebBrowser;
    // ES: activa o desactiva el acceso al mapa
    // EN: active o deactive map access
    property Active: Boolean read FActive write SetActive;
    // ES: intervalo de tiempo para comprovar los eventos del mapa
    // EN: interval of time to check the events of map
    property IntervalEvents: Integer read FIntervalEvents write SetIntervalEvents;
    // ES: opciones de configucacin requeridas
    // EN: required configuration options
    property RequiredProp: TRequiredProp read FRequiredProp write FRequiredProp;
    // ES: opciones de configuracin visuales
    // EN: visual configuration options
    property VisualProp: TVisualProp read FVisualProp write FVisualProp;
    // ES: opciones de configuracin no visuales
    // EN: no visual configurations options
    property NonVisualProp: TNonVisualProp read FNonVisualProp write FNonVisualProp;
    // ES: precisin para los valores de latitud y longitud. 0 = Max precisin, 1..17 decimales de precisin
    // EN: precision for lat and long values. 0 = Max precision, 1..17 precision decimals
    property Precision: Integer read FPrecision write SetPrecision;
    // ES: eventos
    // EN: events
        // ES: evento disparado despus de cargar la 1er pgina y despus de la carga de los mosaicos visibles
        // EN: event fired when the 1st page and the visible tiles have finished loading
    property AfterPageLoaded: TAfterPageLoaded read FAfterPageLoaded write FAfterPageLoaded;
    property OnBoundsChanged: TBoundsChanged read FOnBoundsChanged write FOnBoundsChanged;
    property OnCenterChanged: TLatLngEvent read FOnCenterChanged write FOnCenterChanged;
    property OnClick: TLatLngEvent read FOnClick write FOnClick;
    property OnDblClick: TLatLngEvent read FOnDblClick write FOnDblClick;
    property OnDrag: TNotifyEvent read FOnDrag write FOnDrag;
    property OnDragEnd: TNotifyEvent read FOnDragEnd write FOnDragEnd;
    property OnDragStart: TNotifyEvent read FOnDragStart write FOnDragStart;
    property OnMapTypeIdChanged: TMapTypeIdChanged read FOnMapTypeIdChanged write FOnMapTypeIdChanged;
    property OnMouseMove: TLatLngEvent read FOnMouseMove write FOnMouseMove;
    property OnMouseOut: TLatLngEvent read FOnMouseOut write FOnMouseOut;
    property OnMouseOver: TLatLngEvent read FOnMouseOver write FOnMouseOver;
    property OnRightClick: TLatLngEvent read FOnRightClick write FOnRightClick;
    property OnZoomChanged: TZoomChanged read FOnZoomChanged write FOnZoomChanged;
  end;

  TEventType = (etMarkerClick, etMarkerDblClick, etMarkerDrag, etMarkerDragEnd, etMarkerDragStart,
                etMarkerMouseDown, etMarkerMouseOut, etMarkerMouseOver, etMarkerMouseUp,
                etMarkerRightClick,
                etInfoWinCloseClick, etInfoWinCloseOBO, etInfoWinDisableAP,
                etInfoWinHTMLContent, etInfoWinMaxWidth, etPixelOffset);
  { ****************************************************************************
    ES: clase base para los componentes enlazados al mapa
    EN: base class for a linked components to map
  **************************************************************************** }
  { ****************************************************************************
    internal class
  **************************************************************************** }
  TLinkedComponent = class(TCollectionItem)
  private
    FIdxList: Cardinal;
    FInfoWindow: TBaseInfoWindow;
  protected
    procedure SetIdxList(const Value: Cardinal); virtual;

    procedure OnHTMLContentChange(Sender: TObject);
    procedure OnDisableAutoPanChange(Sender: TObject);
    procedure OnMaxWidthChange(Sender: TObject);
    procedure OnPixelOffsetChange(Sender: TObject);
    procedure OnCloseOtherBeforeOpenChange(Sender: TObject);

    // ES: propiedad IdxList de la clase TGMLinkedComponent. Slo para facilidad de uso interno
    // EN: property IdxList from TGMLinkedComponent class. Just for easy internal use
    property IdxList: Cardinal read FIdxList write SetIdxList;
    property InfoWindow: TBaseInfoWindow read FInfoWindow write FInfoWindow;
  public
    constructor Create(Collection: TCollection); override;
    destructor Destroy; override;

    procedure Assign(Source: TPersistent); override;
  end;

  { ****************************************************************************
    internal class
  **************************************************************************** }
  TLinkedComponents = class(TCollection)
  private
    function GetItems(I: Integer): TLinkedComponent;
    procedure SetItems(I: Integer; const Value: TLinkedComponent);
  protected
    FGMLinkedComponent: TGMLinkedComponent;

    function GetOwner: TPersistent; override;

    function Add: TLinkedComponent;                     // ES: regenera todos los LinkedComponent - EN: reload all LinkedComponent
    function Insert(Index: Integer): TLinkedComponent;  // ES: regenera todos los LinkedComponent - EN: reload all LinkedComponent
    procedure Delete(Index: Integer);                   // ES: regenera todos los LinkedComponent - EN: reload all LinkedComponent
    procedure Move(CurIndex, NewIndex: Integer);        // ES: regenera todos los LinkedComponent - EN: reload all LinkedComponent

    property Items[I: Integer]: TLinkedComponent read GetItems write SetItems; default;
  public
    constructor Create(GMLinkedComponent: TGMLinkedComponent; ItemClass: TCollectionItemClass);
  end;

  TLinkedComponentChange = procedure(Sender: TObject; Index: Integer; LinkedComponent: TLinkedComponent) of object;

  { ****************************************************************************
    internal class
  **************************************************************************** }
  TGMLinkedComponent = class(TGMBase)
  private
    FMap: TGMMap;
    FIdxList: Cardinal;
    FVisualObjects: TLinkedComponents;
    FOnCloseClick: TLinkedComponentChange;
    FAutoUpdate: Boolean;
    FOnCloseOtherBeforeOpenChange: TLinkedComponentChange;
    FOnDisableAutoPanChange: TLinkedComponentChange;
    FOnMaxWidthChange: TLinkedComponentChange;
    FOnPixelOffsetChange: TLinkedComponentChange;
    FOnHTMLContentChange: TLinkedComponentChange;

    procedure SetMap(const Value: TGMMap);
    procedure SetIdxList(const Value: Cardinal);
  protected
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;

    function GetItems(I: Integer): TLinkedComponent;

    // ES: ejecuta un script de JavaScript desde la clase TMap
    // EN: execute a script of JavaScript from TMap class
    function ExecuteScript(NameFunct, Params: string): Boolean; virtual;
    // ES: muestra los objetos en el mapa
    // EN: show objects into the map
    procedure ShowElements; virtual; abstract;
    // ES: control de errores lanzados desde JavaScript
    // EN: error control fired from JavaScript
    procedure ErrorControl; virtual;
    // ES: borra los objetos del mapa
    // EN: delete objects from map
    procedure DeleteMapObjects; virtual;
    // ES: recoge los eventos lanzados desde el mapa para este objeto
    // EN: collect events fired from the map for this object
    procedure EventFired(EventType: TEventType; Params: array of const); virtual;
    // ES: obtiene la classe de la coleccin que implementa
    // EN: obtains the collection class that implements
    function GetCollectionItemClass: TCollectionItemClass; virtual;

    // ES: posicin en la lista FLinkedComponents de la clase TMap
    // EN: position in the list FLinkedComponents of TMap class
    property IdxList: Cardinal read FIdxList write SetIdxList;
    // ES/EN: TCollectionItems
    property Items[I: Integer]: TLinkedComponent read GetItems; default;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    // ES: funciones para aadir, borrar y mover los TCollectionItems
    // EN: functions to add, delete and move the TCollectionItems
    function Add: TLinkedComponent;
    procedure Delete(Index: Integer);
    procedure Move(CurIndex, NewIndex: Integer);

    // ES/EN: TCollection
    property VisualObjects: TLinkedComponents read FVisualObjects write FVisualObjects;
  published
    property Map: TGMMap read FMap write SetMap;
    // ES: si Active, modifica los objetos de forma automtica, sino, necesita recargar el mapa
    // EN: if Active, update objects automatically, if not, you need to reload map
    property AutoUpdate: Boolean read FAutoUpdate write FAutoUpdate;

    // ES/EN: eventos/events
    property OnCloseClick: TLinkedComponentChange read FOnCloseClick write FOnCloseClick;
    property OnHTMLContentChange: TLinkedComponentChange read FOnHTMLContentChange write FOnHTMLContentChange;
    property OnDisableAutoPanChange: TLinkedComponentChange read FOnDisableAutoPanChange write FOnDisableAutoPanChange;
    property OnMaxWidthChange: TLinkedComponentChange read FOnMaxWidthChange write FOnMaxWidthChange;
    property OnPixelOffsetChange: TLinkedComponentChange read FOnPixelOffsetChange write FOnPixelOffsetChange;
    property OnCloseOtherBeforeOpenChange: TLinkedComponentChange read FOnCloseOtherBeforeOpenChange write FOnCloseOtherBeforeOpenChange;
  end;

implementation

uses
  SysUtils, Forms, ActiveX, Controls, MSHTML, StrUtils,
  Lang, WebControl, Windows, GMMarker;

{ TGMMap }
{$R ..\Resources\gmmapres.RES}

{$IF CompilerVersion < 22}
procedure TGMMap.BeforeNavigate2(ASender: TObject; const pDisp: IDispatch;
  var URL, Flags, TargetFrameName, PostData, Headers: OleVariant;
  var Cancel: WordBool);
{$ELSE}
procedure TGMMap.BeforeNavigate2(ASender: TObject; const pDisp: IDispatch;
  const URL, Flags, TargetFrameName, PostData, Headers: OleVariant;
  var Cancel: WordBool);
{$IFEND}
begin
  CurDispatch := nil;
  FDocLoaded := False;
end;

function TGMMap.AddLinkedComponent(LinkedComponent: TGMLinkedComponent): Integer;
begin
  FLinkedComponents.Add(LinkedComponent);
  Inc(FCountLinkedCom);
  LinkedComponent.IdxList := FCountLinkedCom;
  Result := FCountLinkedCom;
end;

procedure TGMMap.Assign(Source: TPersistent);
begin
  inherited;

  if Source is TGMMap then
  begin
    WebBrowser.Assign(TGMMap(Source).WebBrowser);
    Active := TGMMap(Source).Active;
    IntervalEvents := TGMMap(Source).IntervalEvents;
    RequiredProp.Assign(TGMMap(Source).RequiredProp);
    VisualProp.Assign(TGMMap(Source).VisualProp);
    NonVisualProp.Assign(TGMMap(Source).NonVisualProp);
  end;
end;

function TGMMap.LatLngBoundsExtend(LatLng: TLatLng): TLatLngBounds;
const
  StrParams = '%s,%s';
var
  Params: string;
  WC: TWebControl;
begin
  Result := TLatLngBounds.Create;

  Params := Format(StrParams, [LatLng.LatToStr(FPrecision), LatLng.LngToStr(FPrecision)]);
  if not ExecuteScript('LatLngBoundsExtend', Params) then Exit;

  WC := TWebControl.Create(FWebBrowser);
  try
    Result.SW.Lat := ControlPrecision(WC.GetFloatField(LatLngBoundsForm, LatLngBoundsFormSWLat), Precision);
    Result.SW.Lng := ControlPrecision(WC.GetFloatField(LatLngBoundsForm, LatLngBoundsFormSWLng), Precision);
    Result.NE.Lat := ControlPrecision(WC.GetFloatField(LatLngBoundsForm, LatLngBoundsFormNELat), Precision);
    Result.NE.Lng := ControlPrecision(WC.GetFloatField(LatLngBoundsForm, LatLngBoundsFormNELng), Precision);
  finally
    FreeAndNil(WC);
  end;
end;

function TGMMap.LatLngBoundsContains(LatLng: TLatLng): Boolean;
const
  StrParams = '%s,%s';
var
  Params: string;
  WC: TWebControl;
begin
  Result := False;

  Params := Format(StrParams, [LatLng.LatToStr(FPrecision), LatLng.LngToStr(FPrecision)]);

  if not ExecuteScript('LatLngBoundsContains', Params) then Exit;

  WC := TWebControl.Create(FWebBrowser);
  try
    Result := WC.GetBoolField(LatLngBoundsForm, LatLngBoundsFormContains);
  finally
    FreeAndNil(WC);
  end;
end;

function TGMMap.LatLngBoundsContains(Lat, Lng: Real): Boolean;
var
  LatLng: TLatLng;
begin
  LatLng := TLatLng.Create(ControlPrecision(Lat, Precision), ControlPrecision(Lng, Precision));
  try
    Result := LatLngBoundsContains(LatLng);
  finally
    FreeAndNil(LatLng);
  end;
end;

function TGMMap.LatLngBoundsExtend(Lat, Lng: Real): TLatLngBounds;
var
  LatLng: TLatLng;
begin
  LatLng := TLatLng.Create(ControlPrecision(Lat, Precision), ControlPrecision(Lng, Precision));
  try
    Result := LatLngBoundsExtend(LatLng);
  finally
    FreeAndNil(LatLng);
  end;
end;

function TGMMap.LatLngBoundsGetBounds: TLatLngBounds;
var
  WC: TWebControl;
begin
  Result := TLatLngBounds.Create;

  if not ExecuteScript('MapGetBounds', '') then Exit;

  WC := TWebControl.Create(FWebBrowser);
  try
    Result.SW.Lat := ControlPrecision(WC.GetFloatField(LatLngBoundsForm, LatLngBoundsFormSWLat), Precision);
    Result.SW.Lng := ControlPrecision(WC.GetFloatField(LatLngBoundsForm, LatLngBoundsFormSWLng), Precision);
    Result.NE.Lat := ControlPrecision(WC.GetFloatField(LatLngBoundsForm, LatLngBoundsFormNELat), Precision);
    Result.NE.Lng := ControlPrecision(WC.GetFloatField(LatLngBoundsForm, LatLngBoundsFormNELng), Precision);
  finally
    FreeAndNil(WC);
  end;
end;

function TGMMap.LatLngBoundsGetCenter: TLatLng;
var
  WC: TWebControl;
begin
  Result := TLatLng.Create;

  if not ExecuteScript('LatLngBoundsGetCenter', '') then Exit;

  WC := TWebControl.Create(FWebBrowser);
  try
    Result.Lat := ControlPrecision(WC.GetFloatField(LatLngBoundsForm, LatLngBoundsFormSWLat), Precision);
    Result.Lng := ControlPrecision(WC.GetFloatField(LatLngBoundsForm, LatLngBoundsFormSWLng), Precision);
  finally
    FreeAndNil(WC);
  end;
end;

procedure TGMMap.LatLngBoundsSetBounds(SWLat, SWLng, NELat, NELng: Real);
var
  LLB: TLatLngBounds;
begin
  LLB := TLatLngBounds.Create(ControlPrecision(SWLat, Precision),
                              ControlPrecision(SWLng, Precision),
                              ControlPrecision(NELat, Precision),
                              ControlPrecision(NELng, Precision));
  try
    LatLngBoundsSetBounds(LLB);
  finally
    FreeAndNil(LLB);
  end;
end;

procedure TGMMap.LatLngBoundsSetBounds(Bounds: TLatLngBounds);
const
  StrParams = '%s,%s,%s,%s';
var
  Params: string;
begin
  Params := Format(StrParams, [Bounds.SW.LatToStr(FPrecision), Bounds.SW.LngToStr(FPrecision),
                               Bounds.NE.LatToStr(FPrecision), Bounds.NE.LngToStr(FPrecision)]);
  ExecuteScript('MapSetBounds', Params);
end;

function TGMMap.LatLngBoundsToSpan: TLatLng;
var
  WC: TWebControl;
begin
  Result := TLatLng.Create;

  if not ExecuteScript('LatLngBoundsToSpan', '') then Exit;

  WC := TWebControl.Create(FWebBrowser);
  try
    Result.Lat := ControlPrecision(WC.GetFloatField(LatLngBoundsForm, LatLngBoundsFormSWLat), Precision);
    Result.Lng := ControlPrecision(WC.GetFloatField(LatLngBoundsForm, LatLngBoundsFormSWLng), Precision);
  finally
    FreeAndNil(WC);
  end;
end;

procedure TGMMap.LoadBaseWeb;
var
  StringStream: TStringStream;
  PersistStreamInit: IPersistStreamInit;
  StreamAdapter: IStream;
begin
  if not Assigned(FWebBrowser) then Exit;
  // creacin del TStringStream con el string que contiene la pgina web
  StringStream := TStringStream.Create(GetBaseHTMLCode {MAPA_CODE});
  try
    // nos aseguramos de tener algn contenido en Document
    if not Assigned(FWebBrowser.Document) then FWebBrowser.Navigate('about:blank');

    // acceder a la interfaz IPersistStreamInit de Document
    if FWebBrowser.Document.QueryInterface(IPersistStreamInit, PersistStreamInit) = S_OK then
    begin
      // borrar datos actuales
      if PersistStreamInit.InitNew = S_OK then
      begin
        // creacin y inicializacin del IStream
        StreamAdapter:= TStreamAdapter.Create(StringStream);
        try
          Screen.Cursor := crHourGlass;
          // carga de la pgina web mediante IPersistStreamInit
          PersistStreamInit.Load(StreamAdapter);
        finally
          Screen.Cursor := crDefault;
        end;
      end;
    end;
  finally
    StringStream.Free;
  end;
end;

function TGMMap.MapIsNull: Boolean;
var
  WC: TWebControl;
begin
  WC := TWebControl.Create(FWebBrowser);
  try
    Result := WC.GetIntegerField(MapForm, MapFormMapIsNull, 1) = 1;
  finally
    FreeAndNil(WC);
  end;
end;

function TGMMap.MapTypeControlStyleToStr(
  MapTypeControlStyle: TMapTypeControlStyle): string;
begin
  case MapTypeControlStyle of
    mtcDEFAULT: Result := 'DEFAULT';
    mtcDROPDOWN_MENU: Result := 'DROPDOWN_MENU';
    mtcHORIZONTAL_BAR: Result := 'HORIZONTAL_BAR';
    else Result := 'DEFAULT'
  end;
end;

function TGMMap.MapTypeIdsToStr(Delimiter: Char): string;
begin
  Result := '';

  if mtHYBRID in VisualProp.MapTypeCtrl.MapTypeIds then
    Result := Result + 'HYBRID';

  if mtROADMAP in VisualProp.MapTypeCtrl.MapTypeIds then
  begin
    if Result <> '' then Result := Result + Delimiter;
    Result := Result + 'ROADMAP';
  end;

  if mtSATELLITE in VisualProp.MapTypeCtrl.MapTypeIds then
  begin
    if Result <> '' then Result := Result + Delimiter;
    Result := Result + 'SATELLITE';
  end;

  if mtTERRAIN in VisualProp.MapTypeCtrl.MapTypeIds then
  begin
    if Result <> '' then Result := Result + Delimiter;
    Result := Result + 'TERRAIN';
  end;
end;

function TGMMap.MapTypeIdToStr(MapTypeId: TMapTypeId): string;
begin
  case MapTypeId of
    mtHYBRID: Result := 'HYBRID';
    mtROADMAP: Result := 'ROADMAP';
    mtSATELLITE: Result := 'SATELLITE';
    mtTERRAIN: Result := 'TERRAIN';
    else Result := 'ROADMAP';
  end;
end;

function TGMMap.Check: Boolean;
begin
  if not Assigned(FWebBrowser) then
    raise Exception.Create(GetTranslateText('No se ha especificado el objeto WebBrowser', Language));

  if not FActive then
    raise Exception.Create(GetTranslateText('No est activo', Language));

  if not FDocLoaded then
    raise Exception.Create(GetTranslateText('Pgina inicial aun no cargada', Language));

  Result := not (csDesigning in ComponentState);
end;

constructor TGMMap.Create(AOwner: TComponent);
begin
  inherited;

  FActive := False;
  FTimer := TTimer.Create(Self);
  FTimer.Enabled := False;
  FTimer.Interval := 200;
  FTimer.OnTimer := OnTimer;
  FIntervalEvents := 200;
  FRequiredProp := TRequiredProp.Create;
  FVisualProp := TVisualProp.Create;
  FNonVisualProp := TNonVisualProp.Create;

  FDocLoaded := False;
  FLinkedComponents := TList.Create;
  FCountLinkedCom := 0;
end;

destructor TGMMap.Destroy;
begin
  if Assigned(FTimer) then FreeAndNil(FTimer);
  if Assigned(FRequiredProp) then FreeAndNil(FRequiredProp);
  if Assigned(FVisualProp) then FreeAndNil(FVisualProp);
  if Assigned(FNonVisualProp) then FreeAndNil(FNonVisualProp);

  if Assigned(FLinkedComponents) then FreeAndNil(FLinkedComponents);

  inherited;
end;

{$IF CompilerVersion < 22}
procedure TGMMap.DocumentComplete(ASender: TObject; const pDisp: IDispatch;
  var URL: OleVariant);
{$ELSE}
procedure TGMMap.DocumentComplete(ASender: TObject; const pDisp: IDispatch;
  const URL: OleVariant);
{$IFEND}
begin
  if (pDisp = CurDispatch) then  // si son iguales, la pgina se ha cargado
  begin
    FDocLoaded := True;
    CurDispatch := nil;
    if Assigned(AfterPageLoaded) then AfterPageLoaded(Self, True);
  end;
end;

procedure TGMMap.DoMap;
const
  StrParams = '%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s';
var
  Params: String;
  i: Integer;
begin
  Params := Format(StrParams, [
             // required property
             RequiredProp.Center.LatToStr(FPrecision),                          // center -> lat
             RequiredProp.Center.LngToStr(FPrecision),                          // center -> lng
             QuotedStr(MapTypeIdToStr(RequiredProp.MapType)),                   // mapTypeId
             IntToStr(RequiredProp.Zoom),                                       // zoom
             // non visual property
             LowerCase(BoolToStr(DisableDoubleClickZoom in NonVisualProp.Options, True)), // disableDoubleClickZoom
             LowerCase(BoolToStr(Draggable in NonVisualProp.Options, True)),              // draggable
             LowerCase(BoolToStr(KeyboardShortcuts in NonVisualProp.Options, True)),      // keyboardShortcuts
             LowerCase(BoolToStr(NoClear in NonVisualProp.Options, True)),                // noClear
             LowerCase(BoolToStr(ScrollWheel in NonVisualProp.Options, True)),            // scrollwheel
             IntToStr(NonVisualProp.MaxZoom),                                             // maxZoom
             IntToStr(NonVisualProp.MinZoom),                                             // minZoom
             // visual property
             QuotedStr(TColorToStr(VisualProp.BGColor)),                        // backgroundColor
             LowerCase(BoolToStr(VisualProp.MapTypeCtrl.Show, True)),           // mapTypeControl
             QuotedStr(MapTypeIdsToStr(';')),                                   //   mapTypeIds
             QuotedStr(PositionToStr(VisualProp.MapTypeCtrl.Position)),         //   position
             QuotedStr(MapTypeControlStyleToStr(VisualProp.MapTypeCtrl.Style)), //   style
             LowerCase(BoolToStr(VisualProp.OverviewMapCtrl.Show, True)),       // overviewMapCtrl
             LowerCase(BoolToStr(VisualProp.OverviewMapCtrl.Opened, True)),     //   opened
             LowerCase(BoolToStr(VisualProp.PanCtrl.Show, True)),               // PanCtrl
             QuotedStr(PositionToStr(VisualProp.PanCtrl.Position)),             //   position
             LowerCase(BoolToStr(VisualProp.RotateCtrl.Show, True)),            // rotateCtrl
             QuotedStr(PositionToStr(VisualProp.RotateCtrl.Position)),          //   position
             LowerCase(BoolToStr(VisualProp.ScaleCtrl.Show, True)),             // scaleCtrl
             QuotedStr(PositionToStr(VisualProp.ScaleCtrl.Position)),           //   position
             QuotedStr(ScaleControlStyleToStr(VisualProp.ScaleCtrl.Style)),     //   style
             LowerCase(BoolToStr(VisualProp.StreetViewCtrl.Show, True)),        // streetViewCtrl
             QuotedStr(PositionToStr(VisualProp.StreetViewCtrl.Position)),      //   position
             LowerCase(BoolToStr(VisualProp.ZoomCtrl.Show, True)),              // zoomCtrl
             QuotedStr(PositionToStr(VisualProp.ZoomCtrl.Position)),            //   position
             QuotedStr(ZoomControlStyleToStr(VisualProp.ZoomCtrl.Style))        //   style
             ]);
  if not ExecuteScript('DoMap', Params) then Exit;

  // mostramos elementos de los componntes linkados
  // show elements from linked components
  for i := 0 to FLinkedComponents.Count - 1 do
    TGMLinkedComponent(FLinkedComponents[i]).ShowElements;
end;

function TGMMap.ExecuteScript(NameFunct, Params: string): Boolean;
var
  Doc2: IHTMLDocument2;
  Win2: IHTMLWindow2;
begin
  Result := Check;

  if not Result then Exit;

  Doc2 := FWebBrowser.Document as IHTMLDocument2;
  Win2 := Doc2.parentWindow;

  Win2.execScript(NameFunct + '(' + Params + ')', 'JavaScript');

  if MapIsNull then
    raise Exception.Create(GetTranslateText('El mapa todava no ha sido creado', Language));
end;

function TGMMap.ExistLinkedComponent(Id: Cardinal): Integer;
var
  i: Integer;
begin
  Result := -1;
  for i := 0 to FLinkedComponents.Count - 1 do
  begin
    if TGMLinkedComponent(FLinkedComponents[i]).IdxList = Id then
    begin
      Result := i;
      Break;
    end;
  end;
end;

function TGMMap.GetAPIUrl: string;
begin
  Result := 'https://developers.google.com/maps/documentation/javascript/reference#Map';
end;

function TGMMap.GetBaseHTMLCode: string;
var
  List: TStringList;
  Stream: TResourceStream;
begin
  Result := '';
  
  List := TStringList.Create;
  try
    try
      Stream := TResourceStream.Create(HInstance, RES_MAPA_CODE, RT_RCDATA);
      List.LoadFromStream(Stream);
      Result := List.Text;
    except
      raise Exception.Create(GetTranslateText('No se ha podido cargar el recurso', Language));
    end;
  finally
    if Assigned(Stream) then FreeAndNil(Stream);
    if Assigned(List) then FreeAndNil(List);
  end;
end;

function TGMMap.GetCenter: TLatLng;
var
  WC: TWebControl;
begin
  Result := TLatLng.Create;

  if not ExecuteScript('MapGetCenter', '') then Exit;

  WC := TWebControl.Create(FWebBrowser);
  try
    Result.Lat := ControlPrecision(WC.GetFloatField(MapForm, MapFormLat), Precision);
    Result.Lng := ControlPrecision(WC.GetFloatField(MapForm, MapFormLng), Precision);
  finally
    FreeAndNil(WC);
  end;
end;

function TGMMap.GetMapTypeId: TMapTypeId;
var
  WC: TWebControl;
begin
  Result := mtROADMAP;

  if not ExecuteScript('MapGetMapType', '') then Exit;

  WC := TWebControl.Create(FWebBrowser);
  try
    Result := StrToMapTypeId(WC.GetStringField(MapForm, MapFormMapTypeId));
  finally
    FreeAndNil(WC);
  end;
end;

function TGMMap.GetZoom: Integer;
var
  WC: TWebControl;
begin
  Result := 0;

  if not ExecuteScript('MapGetZoom(', '') then Exit;

  WC := TWebControl.Create(FWebBrowser);
  try
    Result := WC.GetIntegerField(MapForm, MapFormZoom);
  finally
    FreeAndNil(WC);
  end;
end;

{$IF CompilerVersion < 22}
procedure TGMMap.NavigateComplete2(ASender: TObject; const pDisp: IDispatch;
  var URL: OleVariant);
{$ELSE}
procedure TGMMap.NavigateComplete2(ASender: TObject; const pDisp: IDispatch;
  const URL: OleVariant);
{$IFEND}
begin
  if CurDispatch = nil then
    CurDispatch := pDisp;
end;

procedure TGMMap.Notification(AComponent: TComponent; Operation: TOperation);
begin
  inherited;

  if (Operation = opRemove) and (AComponent <> nil) then
    if AComponent = FWebBrowser then
    begin
      FWebBrowser.OnBeforeNavigate2 := OldBeforeNavigate2;
      FWebBrowser.OnDocumentComplete := OldDocumentComplete;
      FWebBrowser.OnNavigateComplete2 := OldNavigateComplete2;

      OldBeforeNavigate2 := nil;
      OldDocumentComplete := nil;
      OldNavigateComplete2 := nil;

      FWebBrowser := nil;
    end;
end;

procedure TGMMap.OnTimer(Sender: TObject);
  procedure GetFormFields(WC: TWebControl; var Events: TEventsForm);
  begin
      // map
    Events.BoundsChanged := WC.GetBoolField(EventsForm, EventsFormBoundsChanged);
    Events.CenterChanged := WC.GetBoolField(EventsForm, EventsFormCenterChanged);
    Events.Click := WC.GetBoolField(EventsForm, EventsFormClick);
    Events.DblClick := WC.GetBoolField(EventsForm, EventsFormDblClick);
    Events.Drag := WC.GetBoolField(EventsForm, EventsFormDrag);
    Events.DragEnd := WC.GetBoolField(EventsForm, EventsFormDragEnd);
    Events.DragStart := WC.GetBoolField(EventsForm, EventsFormDragStart);
    Events.MapTypeIdChanged := WC.GetBoolField(EventsForm, EventsFormMapTypeIdChanged);
    Events.MouseMove := WC.GetBoolField(EventsForm, EventsFormMouseMove);
    Events.MouseOut := WC.GetBoolField(EventsForm, EventsFormMouseOut);
    Events.MouseOver := WC.GetBoolField(EventsForm, EventsFormMouseOver);
    Events.RightClick := WC.GetBoolField(EventsForm, EventsFormRightClick);
    Events.TilesLoaded := WC.GetBoolField(EventsForm, EventsFormTilesLoaded);
    Events.ZoomChanged := WC.GetBoolField(EventsForm, EventsFormZoomChanged);
    Events.SWLat := WC.GetFloatField(EventsForm, EventsFormSWLat);
    Events.SWLng := WC.GetFloatField(EventsForm, EventsFormSWLng);
    Events.NELat := WC.GetFloatField(EventsForm, EventsFormNELat);
    Events.NELng := WC.GetFloatField(EventsForm, EventsFormNELng);
    Events.Lat := WC.GetFloatField(EventsForm, EventsFormLat);
    Events.Lng := WC.GetFloatField(EventsForm, EventsFormLng);
    Events.MapTypeId := WC.GetStringField(EventsForm, EventsFormMapTypeId);
    Events.Zoom := WC.GetIntegerField(EventsForm, EventsFormZoom);
      // general
    Events.LinkCompId := WC.GetIntegerField(EventsForm, EventsFormLinkCompId);
    Events.LinkCompZIndex := WC.GetIntegerField(EventsForm, EventsFormLinkCompZIndex);
      // marker
    Events.MarkerClick := WC.GetBoolField(EventsForm, EventsFormMarkerClick);
    Events.MarkerDblClick := WC.GetBoolField(EventsForm, EventsFormMarkerDblClick);
    Events.MarkerDrag := WC.GetBoolField(EventsForm, EventsFormMarkerDrag);
    Events.MarkerDragEnd := WC.GetBoolField(EventsForm, EventsFormMarkerDragEnd);
    Events.MarkerDragStart := WC.GetBoolField(EventsForm, EventsFormMarkerDragStart);
    Events.MarkerMouseDown := WC.GetBoolField(EventsForm, EventsFormMarkerMouseDown);
    Events.MarkerMouseOut := WC.GetBoolField(EventsForm, EventsFormMarkerMouseOut);
    Events.MarkerMouseOver := WC.GetBoolField(EventsForm, EventsFormMarkerMouseOver);
    Events.MarkerMouseUp := WC.GetBoolField(EventsForm, EventsFormMarkerMouseUp);
    Events.MarkerRightClick := WC.GetBoolField(EventsForm, EventsFormMarkerRightClick);
    Events.MarkerLat := WC.GetFloatField(EventsForm, EventsFormMarkerLat);
    Events.MarkerLng := WC.GetFloatField(EventsForm, EventsFormMarkerLng);
      // InfoWindow
    Events.InfoWinId := WC.GetIntegerField(EventsForm, EventsFormInfoWinId);
    Events.InfoWinZIndex := WC.GetIntegerField(EventsForm, EventsFormInfoWinZIndex);
    Events.InfoWinCloseClick := WC.GetBoolField(EventsForm, EventsFormInfoWinCloseClick);
  end;

  procedure InitializeFlags(WC: TWebControl);
  begin
      // map
    WC.WebFormSetFieldValue(EventsForm, EventsFormZoomChanged, '0');
    WC.WebFormSetFieldValue(EventsForm, EventsFormTilesLoaded, '0');
    WC.WebFormSetFieldValue(EventsForm, EventsFormRightClick, '0');
    WC.WebFormSetFieldValue(EventsForm, EventsFormMouseOver, '0');
    WC.WebFormSetFieldValue(EventsForm, EventsFormMouseOut, '0');
    WC.WebFormSetFieldValue(EventsForm, EventsFormMouseMove, '0');
    WC.WebFormSetFieldValue(EventsForm, EventsFormMapTypeIdChanged, '0');
    WC.WebFormSetFieldValue(EventsForm, EventsFormDragStart, '0');
    WC.WebFormSetFieldValue(EventsForm, EventsFormDragEnd, '0');
    WC.WebFormSetFieldValue(EventsForm, EventsFormDrag, '0');
    WC.WebFormSetFieldValue(EventsForm, EventsFormDblClick, '0');
    WC.WebFormSetFieldValue(EventsForm, EventsFormClick, '0');
    WC.WebFormSetFieldValue(EventsForm, EventsFormCenterChanged, '0');
    WC.WebFormSetFieldValue(EventsForm, EventsFormBoundsChanged, '0');
      // marker
    WC.WebFormSetFieldValue(EventsForm, EventsFormMarkerClick, '0');
    WC.WebFormSetFieldValue(EventsForm, EventsFormMarkerDblClick, '0');
    WC.WebFormSetFieldValue(EventsForm, EventsFormMarkerDrag, '0');
    WC.WebFormSetFieldValue(EventsForm, EventsFormMarkerDragEnd, '0');
    WC.WebFormSetFieldValue(EventsForm, EventsFormMarkerDragStart, '0');
    WC.WebFormSetFieldValue(EventsForm, EventsFormMarkerMouseDown, '0');
    WC.WebFormSetFieldValue(EventsForm, EventsFormMarkerMouseOut, '0');
    WC.WebFormSetFieldValue(EventsForm, EventsFormMarkerMouseOver, '0');
    WC.WebFormSetFieldValue(EventsForm, EventsFormMarkerMouseUp, '0');
    WC.WebFormSetFieldValue(EventsForm, EventsFormMarkerRightClick, '0');
      // InfoWindow
    WC.WebFormSetFieldValue(EventsForm, EventsFormInfoWinCloseClick, '0');
      // general
    WC.WebFormSetFieldValue(EventsForm, EventsFormEventFired, '0');
  end;

  procedure MapEvent(Events: TEventsForm);
  var
    LLB: TLatLngBounds;
    LL: TLatLng;
  begin
    // Map bounds_changed
    if Events.BoundsChanged and Assigned(FOnBoundsChanged) then
    begin
      LLB := TLatLngBounds.Create(
                      ControlPrecision(Events.SWLat, Precision),
                      ControlPrecision(Events.SWLng, Precision),
                      ControlPrecision(Events.NELat, Precision),
                      ControlPrecision(Events.NELng, Precision));
      try
        FOnBoundsChanged(Self, LLB);
      finally
        FreeAndNil(LLB);
      end;
    end;

    // Map center_changed, click, dblclick, mousemove, mouseout, mouseover, rightclick
    if Events.CenterChanged or Events.Click or Events.DblClick or Events.MouseMove or
       Events.MouseOut or Events.MouseOver or Events.RightClick then
    begin
      LL := TLatLng.Create(ControlPrecision(Events.Lat, Precision), ControlPrecision(Events.Lng, Precision));
      try
        if Events.CenterChanged then
        begin
          FRequiredProp.Center.Assign(LL);
          if Assigned(FOnCenterChanged) then FOnCenterChanged(Self, LL);
        end;
        if Events.Click and Assigned(FOnClick) then FOnClick(Self, LL);
        if Events.DblClick and Assigned(FOnDblClick) then FOnDblClick(Self, LL);
        if Events.MouseMove and Assigned(FOnMouseMove) then FOnMouseMove(Self, LL);
        if Events.MouseOut and Assigned(FOnMouseOut) then FOnMouseOut(Self, LL);
        if Events.MouseOver and Assigned(FOnMouseOver) then FOnMouseOver(Self, LL);
        if Events.RightClick and Assigned(FOnRightClick) then FOnRightClick(Self, LL);
      finally
        FreeAndNil(LL);
      end;
    end;

    // Map drag, dargend, dragstart
    if Events.Drag and Assigned(FOnDrag) then FOnDrag(Self);
    if Events.DragEnd then
    begin
      FRequiredProp.Center.Assign(GetCenter);
      if Assigned(FOnDragEnd) then FOnDragEnd(Self);
    end;
    if Events.DragStart and Assigned(FOnDragStart) then FOnDragStart(Self);

    // Map MapTypeIdChanged
    if Events.MapTypeIdChanged then
    begin
      FRequiredProp.MapType := StrToMapTypeId(Events.MapTypeId);
      if Assigned(FOnMapTypeIdChanged) then FOnMapTypeIdChanged(Self, RequiredProp.MapType);
    end;

    // Map TilesLoaded
    if Events.TilesLoaded and Assigned(FAfterPageLoaded) then AfterPageLoaded(Self, False);

    // Map ZoomChanged
    if Events.ZoomChanged then
    begin
      FRequiredProp.Zoom := Events.Zoom;
      if Assigned(FOnZoomChanged) then FOnZoomChanged(Self, Events.Zoom);
    end;
  end;

  procedure MarkerEvent(Events: TEventsForm);
  var
    LinkComp: Integer;
  begin
    // Marker events
    if Events.MarkerClick or Events.MarkerDblClick or Events.MarkerDrag or Events.MarkerDragEnd or
       Events.MarkerDragStart or Events.MarkerMouseDown or Events.MarkerMouseOut or
       Events.MarkerMouseOver or Events.MarkerMouseUp or Events.MarkerRightClick then
    begin
      LinkComp := ExistLinkedComponent(Events.LinkCompId);
      if LinkComp = -1 then
        raise Exception.Create(GetTranslateText('Id de JavaScript inexistente', Language));

      if not (TGMLinkedComponent(FLinkedComponents[LinkComp]) is TGMMarker) then
        raise Exception.Create(GetTranslateText('Id de JavaScript incorrecto', Language));

      with TGMLinkedComponent(FLinkedComponents[LinkComp]), Events do
      begin
        if MarkerClick then EventFired(etMarkerClick, [MarkerLat, MarkerLng, LinkCompZIndex]);
        if MarkerDblClick then EventFired(etMarkerDblClick, [MarkerLat, MarkerLng, LinkCompZIndex]);
        if MarkerDrag then EventFired(etMarkerDrag, [MarkerLat, MarkerLng, LinkCompZIndex]);
        if MarkerDragEnd then EventFired(etMarkerDragEnd, [MarkerLat, MarkerLng, LinkCompZIndex]);
        if MarkerDragStart then EventFired(etMarkerDragStart, [MarkerLat, MarkerLng, LinkCompZIndex]);
        if MarkerMouseDown then EventFired(etMarkerMouseDown, [MarkerLat, MarkerLng, LinkCompZIndex]);
        if MarkerMouseOut then EventFired(etMarkerMouseOut, [MarkerLat, MarkerLng, LinkCompZIndex]);
        if MarkerMouseOver then EventFired(etMarkerMouseOver, [MarkerLat, MarkerLng, LinkCompZIndex]);
        if MarkerMouseUp then EventFired(etMarkerMouseUp, [MarkerLat, MarkerLng, LinkCompZIndex]);
        if MarkerRightClick then EventFired(etMarkerRightClick, [MarkerLat, MarkerLng, LinkCompZIndex]);
      end;
    end;
  end;

  procedure InfoWindowEvent(Events: TEventsForm);
  var
    LinkComp: Integer;
  begin
    // InfoWindow events
    if Events.InfoWinCloseClick then
    begin
      LinkComp := ExistLinkedComponent(Events.LinkCompId);
      if LinkComp = -1 then
        raise Exception.Create(GetTranslateText('Id de JavaScript inexistente', Language));

      with TGMLinkedComponent(FLinkedComponents[LinkComp]), Events do
      begin
        if InfoWinCloseClick then EventFired(etInfoWinCloseClick, [LinkCompZIndex]);
      end;
    end;
  end;
var
  WC: TWebControl;
  Events: TEventsForm;
begin
  if not Assigned(FWebBrowser) or not FDocLoaded then Exit;
  if csDesigning in ComponentState then Exit;

  WC := TWebControl.Create(FWebBrowser);
  try
    if WC.GetIntegerField(EventsForm, EventsFormEventFired) = 0 then
    begin
      FreeAndNil(WC);
      Exit;
    end;

    // cogemos campos del formulario // get form fields
    GetFormFields(WC, Events);

    // inicializamos banderas // initialize flags
    InitializeFlags(WC);
  finally
    if Assigned(WC) then FreeAndNil(WC);
  end;

  // map events
  MapEvent(Events);

  // marker events
  MarkerEvent(Events);

  // infoWindow event
  InfoWindowEvent(Events);
end;

procedure TGMMap.PanBy(x, y: Integer);
begin
  ExecuteScript('MapPanBy', Format('%s,%s', [IntToStr(x), IntToStr(y)]));
end;

procedure TGMMap.PanTo(LatLng: TLatLng);
begin
  ExecuteScript('MapPanTo', Format('%s,%s', [LatLng.LatToStr(FPrecision), LatLng.LngToStr(FPrecision)]));
end;

procedure TGMMap.PanTo(const Lat, Lng: Real);
var
  LatLng: TLatLng;
begin
  LatLng := TLatLng.Create(ControlPrecision(Lat, Precision), ControlPrecision(Lng, Precision));
  try
    PanTo(LatLng);
  finally
    if Assigned(LatLng) then FreeAndNil(LatLng);
  end;
end;

function TGMMap.PositionToStr(Position: TControlPosition): string;
begin
  case Position of
    cpBOTTOM_CENTER: Result := 'BOTTOM_CENTER';
    cpBOTTOM_LEFT: Result := 'BOTTOM_LEFT';
    cpBOTTOM_RIGHT: Result := 'BOTTOM_RIGHT';
    cpLEFT_BOTTOM: Result := 'LEFT_BOTTOM';
    cpLEFT_CENTER: Result := 'LEFT_CENTER';
    cpLEFT_TOP: Result := 'LEFT_TOP';
    cpRIGHT_BOTTOM: Result := 'RIGHT_BOTTOM';
    cpRIGHT_CENTER: Result := 'RIGHT_CENTER';
    cpRIGHT_TOP: Result := 'RIGHT_TOP';
    cpTOP_CENTER: Result := 'TOP_CENTER';
    cpTOP_LEFT: Result := 'TOP_LEFT';
    cpTOP_RIGHT: Result := 'TOP_RIGHT';
    else Result := 'BOTTOM_LEFT'
  end;
end;

procedure TGMMap.RemoveLinkedComponent(LinkedComponent: TGMLinkedComponent);
begin
  FLinkedComponents.Remove(LinkedComponent);
end;

function TGMMap.ScaleControlStyleToStr(
  ScaleControlStyle: TScaleControlStyle): string;
begin
  case ScaleControlStyle of
    scDEFAULT: Result := 'DEFAULT';
    else Result := 'DEFAULT';
  end;
end;

procedure TGMMap.SetActive(const Value: Boolean);
begin
  if FActive = Value then Exit;

  FActive := Value;
  FTimer.Enabled := FActive;

  if csDesigning in ComponentState then Exit;

  if Assigned(FWebBrowser) then
  begin
    if FActive then
      LoadBaseWeb
    else
      FWebBrowser.Navigate('about:blank');
  end
  else
    FActive := False;
end;

procedure TGMMap.SetCenter(LatLng: TLatLng);
begin
  ExecuteScript('MapSetCenter', Format('%s,%s', [LatLng.LatToStr(FPrecision), LatLng.LngToStr(FPrecision)]));
end;

procedure TGMMap.SetCenter(const Lat, Lng: Real);
var
  LatLng: TLatLng;
begin
  LatLng := TLatLng.Create(ControlPrecision(Lat, Precision), ControlPrecision(Lng, Precision));
  try
    SetCenter(LatLng);
  finally
    if Assigned(LatLng) then FreeAndNil(LatLng);
  end;
end;

procedure TGMMap.SetIntervalEvents(const Value: Integer);
begin
  if FIntervalEvents = Value then Exit;

  FIntervalEvents := Value;

  if Assigned(FTimer) then FTimer.Interval := FIntervalEvents;
end;

procedure TGMMap.SetMapTypeId(MapTypeId: TMapTypeId);
begin
  SetMapTypeId(MapTypeIdToStr(MapTypeId));
end;

procedure TGMMap.SetMapTypeId(const MapTypeId: string);
begin
  ExecuteScript('MapSetMapTypeId', QuotedStr(MapTypeId));
end;

procedure TGMMap.SetPrecision(const Value: Integer);
begin
  if FPrecision = Value then Exit;

  FPrecision := Value;

  if FPrecision < 0 then FPrecision := 0;
  if FPrecision > 17 then FPrecision := 17;
end;

procedure TGMMap.SetWebBrowser(const Value: TWebBrowser);
begin
  if FWebBrowser = Value then Exit;

  FWebBrowser := Value;

  if Assigned(FWebBrowser) then
  begin
    OldBeforeNavigate2 := FWebBrowser.OnBeforeNavigate2;
    OldDocumentComplete := FWebBrowser.OnDocumentComplete;
    OldNavigateComplete2 := FWebBrowser.OnNavigateComplete2;

    FWebBrowser.OnBeforeNavigate2 := BeforeNavigate2;
    FWebBrowser.OnDocumentComplete := DocumentComplete;
    FWebBrowser.OnNavigateComplete2 := NavigateComplete2;

    if FActive then LoadBaseWeb;
  end;
end;

procedure TGMMap.SetZoom(Zoom: Integer);
begin
  ExecuteScript('MapSetZoom', IntToStr(Zoom));
end;

function TGMMap.StrToMapTypeControlStyle(
  MapTypeControlStyle: string): TMapTypeControlStyle;
begin
  case AnsiIndexStr(MapTypeControlStyle, ['DEFAULT', 'DROPDOWN_MENU', 'HORIZONTAL_BAR']) of
    0: Result := mtcDEFAULT;
    1: Result := mtcDROPDOWN_MENU;
    2: Result := mtcHORIZONTAL_BAR;
    else Result := mtcDEFAULT;
  end;
end;

function TGMMap.StrToMapTypeId(MapTypeId: string): TMapTypeId;
begin
  case AnsiIndexStr(MapTypeId, ['HYBRID', 'ROADMAP', 'SATELLITE', 'TERRAIN']) of
    0: Result := mtHYBRID;
    1: Result := mtROADMAP;
    2: Result := mtSATELLITE;
    3: Result := mtTERRAIN;
    else Result := mtROADMAP;
  end;
end;

function TGMMap.StrToPosition(Position: string): TControlPosition;
begin
  case AnsiIndexStr(Position, ['BOTTOM_CENTER', 'BOTTOM_LEFT', 'BOTTOM_RIGHT',
                               'LEFT_BOTTOM', 'LEFT_CENTER', 'LEFT_TOP',
                               'RIGHT_BOTTOM', 'RIGHT_CENTER', 'RIGHT_TOP',
                               'TOP_CENTER', 'TOP_LEFT', 'TOP_RIGHT']) of
    0: Result := cpBOTTOM_CENTER;
    1: Result := cpBOTTOM_LEFT;
    2: Result := cpBOTTOM_RIGHT;
    3: Result := cpLEFT_BOTTOM;
    4: Result := cpLEFT_CENTER;
    5: Result := cpLEFT_TOP;
    6: Result := cpRIGHT_BOTTOM;
    7: Result := cpRIGHT_CENTER;
    8: Result := cpRIGHT_TOP;
    9: Result := cpTOP_CENTER;
    10: Result := cpTOP_LEFT;
    11: Result := cpTOP_RIGHT;
    else Result := cpTOP_LEFT;
  end;
end;

function TGMMap.StrToScaleControlStyle(
  ScaleControlStyle: string): TScaleControlStyle;
begin
  case AnsiIndexStr(ScaleControlStyle, ['DEFAULT']) of
    0: Result := scDEFAULT;
    else Result := scDEFAULT;
  end;
end;

function TGMMap.StrToZoomControlStyle(
  ZoomControlStyle: string): TZoomControlStyle;
begin
  case AnsiIndexStr(ZoomControlStyle, ['DEFAULT', 'LARGE', 'SMALL']) of
    0: Result := zcDEFAULT;
    1: Result := zcLARGE;
    2: Result := zcSMALL;
    else Result := zcDEFAULT;
  end;
end;

function TGMMap.TColorToStr(Color: TColor): string;
  function GetRValue(rgb: LongWord): Byte;
  begin
    Result := Byte(rgb);
  end;

  function GetGValue(rgb: LongWord): Byte;
  begin
    Result := Byte(rgb shr 8);
  end;

  function GetBValue(rgb: LongWord): Byte;
  begin
    Result := Byte(rgb shr 16);
  end;
var
  tmpRGB: LongWord;
begin
  tmpRGB := ColorToRGB(Color);
  Result := Format('#%.2x%.2x%.2x',
                   [GetRValue(tmpRGB),
                    GetGValue(tmpRGB),
                    GetBValue(tmpRGB)]);
end;

function TGMMap.ZoomControlStyleToStr(
  ZoomControlStyle: TZoomControlStyle): string;
begin
  case ZoomControlStyle of
    zcDEFAULT: Result := 'DEFAULT';
    zcLARGE: Result := 'LARGE';
    zcSMALL: Result := 'SMALL';
    else Result := 'DEFAULT';
  end;
end;

{ TRequiredProp }

procedure TRequiredProp.Assign(Source: TPersistent);
begin
  if Source is TRequiredProp then
  begin
    Center.Assign(TRequiredProp(Source).Center);
    MapType := TRequiredProp(Source).MapType;
    Zoom := TRequiredProp(Source).Zoom;
  end
  else
    inherited Assign(Source);
end;

constructor TRequiredProp.Create;
begin
  FCenter := TLatLng.Create(0,0);
  FMapType := mtROADMAP;
  FZoom := 8;
end;

destructor TRequiredProp.Destroy;
begin
  if Assigned(FCenter) then FreeAndNil(FCenter);

  inherited;
end;

{ TVisualProp }

procedure TVisualProp.Assign(Source: TPersistent);
begin
  if Source is TVisualProp then
  begin
    MapTypeCtrl.Assign(TVisualProp(Source).MapTypeCtrl);
    OverviewMapCtrl.Assign(TVisualProp(Source).OverviewMapCtrl);
    PanCtrl.Assign(TVisualProp(Source).PanCtrl);
    RotateCtrl.Assign(TVisualProp(Source).RotateCtrl);
    ScaleCtrl.Assign(TVisualProp(Source).ScaleCtrl);
    StreetViewCtrl.Assign(TVisualProp(Source).StreetViewCtrl);
    ZoomCtrl.Assign(TVisualProp(Source).ZoomCtrl);
  end
  else
    inherited Assign(Source);
end;

constructor TVisualProp.Create;
begin
  FBGColor := $00EEF0EF;
  FMapTypeCtrl := TMapTypeControlOptions.Create;
  FOverviewMapCtrl := TOverviewMapControlOptions.Create;
  FPanCtrl := TPanControlOptions.Create;
  FRotateCtrl := TRotateControlOptions.Create;
  FScaleCtrl := TScaleControlOptions.Create;
  FStreetViewCtrl := TStreetViewControlOptions.Create;
  FZoomCtrl := TZoomControlOptions.Create;
end;

destructor TVisualProp.Destroy;
begin
  if Assigned(FMapTypeCtrl) then FreeAndNil(FMapTypeCtrl);
  if Assigned(FOverviewMapCtrl) then FreeAndNil(FOverviewMapCtrl);
  if Assigned(FPanCtrl) then FreeAndNil(FPanCtrl);
  if Assigned(FRotateCtrl) then FreeAndNil(FRotateCtrl);
  if Assigned(FScaleCtrl) then FreeAndNil(FScaleCtrl);
  if Assigned(FStreetViewCtrl) then FreeAndNil(FStreetViewCtrl);
  if Assigned(FZoomCtrl) then FreeAndNil(FZoomCtrl);

  inherited;
end;

{ TMapTypeControlOptions }

procedure TMapTypeControlOptions.Assign(Source: TPersistent);
begin
  if Source is TMapTypeControlOptions then
  begin
    MapTypeIds := TMapTypeControlOptions(Source).MapTypeIds;
    Position := TMapTypeControlOptions(Source).Position;
    Style := TMapTypeControlOptions(Source).Style;
    Show := TMapTypeControlOptions(Source).Show;
  end
  else
    inherited Assign(Source);
end;

constructor TMapTypeControlOptions.Create;
begin
  FPosition := cpTOP_RIGHT;
  FStyle := mtcDEFAULT;
  FShow := True;
  FMapTypeIds := [mtHYBRID, mtROADMAP, mtSATELLITE, mtTERRAIN];
end;

{ TOverviewMapControlOptions }

procedure TOverviewMapControlOptions.Assign(Source: TPersistent);
begin
  if Source is TOverviewMapControlOptions then
  begin
    Opened := TOverviewMapControlOptions(Source).Opened;
    Show := TOverviewMapControlOptions(Source).Show;
  end
  else
    inherited Assign(Source);
end;

constructor TOverviewMapControlOptions.Create;
begin
  FOpened := True;
  FShow := True;
end;

{ TPanControlOptions }

procedure TPanControlOptions.Assign(Source: TPersistent);
begin
  if Source is TPanControlOptions then
  begin
    Position := TPanControlOptions(Source).Position;
    Show := TPanControlOptions(Source).Show;
  end
  else
    inherited Assign(Source);
end;

constructor TPanControlOptions.Create;
begin
  FPosition := cpTOP_LEFT;
  FShow := True;
end;

{ TRotateControlOptions }

procedure TRotateControlOptions.Assign(Source: TPersistent);
begin
  if Source is TRotateControlOptions then
  begin
    Position := TRotateControlOptions(Source).Position;
    Show := TRotateControlOptions(Source).Show;
  end
  else
    inherited Assign(Source);
end;

constructor TRotateControlOptions.Create;
begin
  FPosition := cpTOP_LEFT;
  FShow := True;
end;

{ TScaleControlOptions }

procedure TScaleControlOptions.Assign(Source: TPersistent);
begin
  if Source is TScaleControlOptions then
  begin
    Position := TScaleControlOptions(Source).Position;
    Style := TScaleControlOptions(Source).Style;
    Show := TScaleControlOptions(Source).Show;
  end
  else
    inherited Assign(Source);
end;

constructor TScaleControlOptions.Create;
begin
  FPosition := cpBOTTOM_LEFT;
  FStyle := scDEFAULT;
  FShow := True;
end;

{ TStreetViewControlOptions }

procedure TStreetViewControlOptions.Assign(Source: TPersistent);
begin
  if Source is TStreetViewControlOptions then
  begin
    Position := TStreetViewControlOptions(Source).Position;
    Show := TStreetViewControlOptions(Source).Show;
  end
  else
    inherited Assign(Source);
end;

constructor TStreetViewControlOptions.Create;
begin
  FPosition := cpTOP_LEFT;
  FShow := True;
end;

{ TZoomControlOptions }

procedure TZoomControlOptions.Assign(Source: TPersistent);
begin
  if Source is TZoomControlOptions then
  begin
    Position := TZoomControlOptions(Source).Position;
    Style := TZoomControlOptions(Source).Style;
    Show := TZoomControlOptions(Source).Show;
  end
  else
    inherited Assign(Source);
end;

constructor TZoomControlOptions.Create;
begin
  FPosition := cpTOP_LEFT;
  FStyle := zcDEFAULT;
  FShow := True;
end;

{ TNonVisualProp }

procedure TNonVisualProp.Assign(Source: TPersistent);
begin
  if Source is TNonVisualProp then
  begin
    Options := TNonVisualProp(Source).Options;
    MinZoom := TNonVisualProp(Source).MinZoom;
    MaxZoom := TNonVisualProp(Source).MaxZoom;
  end
  else
    inherited Assign(Source);
end;

constructor TNonVisualProp.Create;
begin
  FMaxZoom := 0;
  FMinZoom := 0;
  FOptions := [Draggable, KeyboardShortcuts, ScrollWheel];
end;

procedure TNonVisualProp.SetMaxZoom(const Value: Integer);
begin
  if FMaxZoom = Value then Exit;

  FMaxZoom := Value;

  if FMaxZoom < 0 then FMaxZoom := 0;
  if FMaxZoom > 20 then FMaxZoom := 20;
end;

procedure TNonVisualProp.SetMinZoom(const Value: Integer);
begin
  if FMinZoom = Value then Exit;

  FMinZoom := Value;

  if FMinZoom < 0 then FMinZoom := 0;
  if FMinZoom > 20 then FMinZoom := 20;
end;

{ TGMLinkedComponent }

function TGMLinkedComponent.Add: TLinkedComponent;
begin
  Result := FVisualObjects.Add;
end;

constructor TGMLinkedComponent.Create(AOwner: TComponent);
begin
  inherited;

  FIdxList := 0;
  FVisualObjects := TLinkedComponents.Create(Self, GetCollectionItemClass);
  FAutoUpdate := True;
end;

procedure TGMLinkedComponent.Delete(Index: Integer);
begin
  FVisualObjects.Delete(Index);
end;

procedure TGMLinkedComponent.DeleteMapObjects;
begin
  ExecuteScript('DeleteObjects', IntToStr(IdxList));
end;

destructor TGMLinkedComponent.Destroy;
begin
  if Assigned(FVisualObjects) then FreeAndNil(FVisualObjects);
  if Assigned(FMap) then FMap.RemoveLinkedComponent(Self);

  inherited;
end;

procedure TGMLinkedComponent.ErrorControl;
var
  WC: TWebControl;
  ErrCode: Integer;
begin
  if not Assigned(Map) or not Map.Active then Exit;

  WC := TWebControl.Create(Map.WebBrowser);
  try
    ErrCode := WC.GetIntegerField(ErrorForm, ErrorFormErrorCode);
  finally
    FreeAndNil(WC);
  end;

  case ErrCode of
    1: // objeto no encontrado en JavaScript // Object not find in JavaScript
      raise Exception.Create(GetTranslateText('Este objeto no tiene relacin en JavaScript', Map.Language));
  end;
end;

procedure TGMLinkedComponent.EventFired(EventType: TEventType;
  Params: array of const);
begin
  if EventType = etInfoWinCloseClick then
    if Assigned(OnCloseClick) then OnCloseClick(Self, Params[0].VInteger, Items[Params[0].VInteger]);
end;

function TGMLinkedComponent.ExecuteScript(NameFunct, Params: string): Boolean;
begin
  Result := False;
  if (csDesigning in ComponentState) or not Assigned(FMap) then Exit;

  Result := FMap.ExecuteScript(NameFunct, Params);
end;

function TGMLinkedComponent.GetCollectionItemClass: TCollectionItemClass;
begin
  Result := TLinkedComponent;
end;

function TGMLinkedComponent.GetItems(I: Integer): TLinkedComponent;
begin
  Result := TLinkedComponent(FVisualObjects[i]);
end;

procedure TGMLinkedComponent.Move(CurIndex, NewIndex: Integer);
begin
  FVisualObjects.Move(CurIndex, NewIndex);
end;

procedure TGMLinkedComponent.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited;

  if (Operation = opRemove) and (AComponent <> nil) and (AComponent = FMap) then
    FMap := nil;
end;

procedure TGMLinkedComponent.SetIdxList(const Value: Cardinal);
var
  i: Integer;
begin
  if FIdxList = Value then Exit;

  FIdxList := Value;
  if Assigned(FVisualObjects) then
    for i := 0 to FVisualObjects.Count - 1 do
      Items[i].IdxList := FIdxList;
end;

procedure TGMLinkedComponent.SetMap(const Value: TGMMap);
begin
  if FMap = Value then Exit;

  if Assigned(FMap) then
  begin
    if not (csDesigning in ComponentState) and (FIdxList <> 0) and
      Map.Active and Map.FDocLoaded then
    begin
      DeleteMapObjects;
      IdxList := 0;
    end;
    FMap.RemoveLinkedComponent(Self);
  end;
  FMap := Value;
  if Assigned(FMap) then
  begin
    {IdxList := }FMap.AddLinkedComponent(Self);
    if not (csDesigning in ComponentState) and (FIdxList <> 0) and
       Map.Active and Map.FDocLoaded then ShowElements;
  end;
end;

{ TLinkedComponents }

function TLinkedComponents.Add: TLinkedComponent;
begin
  Result := TLinkedComponent(inherited Add);

  if Assigned(FGMLinkedComponent) then FGMLinkedComponent.ShowElements;
end;

constructor TLinkedComponents.Create(GMLinkedComponent: TGMLinkedComponent;
  ItemClass: TCollectionItemClass);
begin
  inherited Create(ItemClass);

  FGMLinkedComponent := GMLinkedComponent;
end;

procedure TLinkedComponents.Delete(Index: Integer);
begin
  inherited Delete(Index);

  if Assigned(FGMLinkedComponent) then FGMLinkedComponent.ShowElements;
end;

function TLinkedComponents.GetItems(I: Integer): TLinkedComponent;
begin
  Result := TLinkedComponent(inherited Items[I]);
end;

function TLinkedComponents.GetOwner: TPersistent;
begin
  Result := FGMLinkedComponent;
end;

function TLinkedComponents.Insert(Index: Integer): TLinkedComponent;
begin
  Result := TLinkedComponent(inherited Insert(Index));

  if Assigned(FGMLinkedComponent) then FGMLinkedComponent.ShowElements;
end;

procedure TLinkedComponents.Move(CurIndex, NewIndex: Integer);
var
  LinCom: TCollectionItem;
begin
  LinCom := ItemClass.Create(nil);
  LinCom.Assign(Items[CurIndex]);

  Delete(CurIndex);
  Insert(NewIndex);
  Items[NewIndex].Assign(LinCom);

  if Assigned(FGMLinkedComponent) then FGMLinkedComponent.ShowElements;
end;

procedure TLinkedComponents.SetItems(I: Integer; const Value: TLinkedComponent);
begin
  inherited SetItem(I, Value);
end;

{ TLinkedComponent }

procedure TLinkedComponent.Assign(Source: TPersistent);
begin
  if Source is TBaseInfoWindow then
    InfoWindow.Assign(TLinkedComponent(Source).InfoWindow)
  else
    inherited Assign(Source);
end;

constructor TLinkedComponent.Create(Collection: TCollection);
begin
  inherited;

  FInfoWindow := TBaseInfoWindow.Create(Self);
  FInfoWindow.OnCloseOtherBeforeOpenChange := OnCloseOtherBeforeOpenChange;
  FInfoWindow.OnHTMLContentChange := OnHTMLContentChange;
  FInfoWindow.OnDisableAutoPanChange := OnDisableAutoPanChange;
  FInfoWindow.OnMaxWidthChange := OnMaxWidthChange;
  FInfoWindow.OnPixelOffsetChange := OnPixelOffsetChange;

  if Assigned(Collection) and (Collection is TLinkedComponents) and
     Assigned(TLinkedComponents(Collection).FGMLinkedComponent) then
    FIdxList := TLinkedComponents(Collection).FGMLinkedComponent.IdxList;
end;

destructor TLinkedComponent.Destroy;
begin
  if Assigned(FInfoWindow) then FreeAndNil(FInfoWindow);

  inherited;
end;

procedure TLinkedComponent.OnCloseOtherBeforeOpenChange(Sender: TObject);
const
  StrParams = '%s,%s,%s';
var
  Params: string;
begin
  if Assigned(Collection) and (Collection is TLinkedComponents) and
     Assigned(TLinkedComponents(Collection).FGMLinkedComponent) and
     TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).AutoUpdate then
  begin
    Params := Format(StrParams, [
                      IntToStr(FIdxList),
                      LowerCase(BoolToStr(FInfoWindow.CloseOtherBeforeOpen, True)),
                      IntToStr(Index)]);
    TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).ExecuteScript('InfoWindowSetCloseOtherBeforeOpen', Params);

    // ES: control de errores // EN: error control
    TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).ErrorControl;

    // ES/EN: evento/event
    if Assigned(TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).OnCloseOtherBeforeOpenChange) then
      TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).OnCloseOtherBeforeOpenChange(TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent), Index, Self);
  end;
end;

procedure TLinkedComponent.OnDisableAutoPanChange(Sender: TObject);
const
  StrParams = '%s,%s,%s';
var
  Params: string;
begin
  if Assigned(Collection) and (Collection is TLinkedComponents) and
     Assigned(TLinkedComponents(Collection).FGMLinkedComponent) and
     TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).AutoUpdate then
  begin
    Params := Format(StrParams, [
                      IntToStr(FIdxList),
                      LowerCase(BoolToStr(FInfoWindow.DisableAutoPan, True)),
                      IntToStr(Index)]);
    TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).ExecuteScript('InfoWindowSetDisableAutoPan', Params);

    // ES: control de errores // EN: error control
    TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).ErrorControl;

    // ES/EN: evento/event
    if Assigned(TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).OnDisableAutoPanChange) then
      TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).OnDisableAutoPanChange(TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent), Index, Self);
  end;
end;

procedure TLinkedComponent.OnHTMLContentChange(Sender: TObject);
const
  StrParams = '%s,%s,%s';
var
  Params: string;
begin
  if Assigned(Collection) and (Collection is TLinkedComponents) and
     Assigned(TLinkedComponents(Collection).FGMLinkedComponent) and
     TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).AutoUpdate then
  begin
    Params := Format(StrParams, [
                      IntToStr(FIdxList),
                      QuotedStr(FInfoWindow.GetConvertedString),
                      IntToStr(Index)]);
    TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).ExecuteScript('InfoWindowSetHTMLContent', Params);

    // ES: control de errores // EN: error control
    TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).ErrorControl;

    // ES/EN: evento/event
    if Assigned(TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).OnHTMLContentChange) then
      TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).OnHTMLContentChange(TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent), Index, Self);
  end;
end;

procedure TLinkedComponent.OnMaxWidthChange(Sender: TObject);
const
  StrParams = '%s,%s,%s';
var
  Params: string;
begin
  if Assigned(Collection) and (Collection is TLinkedComponents) and
     Assigned(TLinkedComponents(Collection).FGMLinkedComponent) and
     TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).AutoUpdate then
  begin
    Params := Format(StrParams, [
                      IntToStr(FIdxList),
                      IntToStr(FInfoWindow.MaxWidth),
                      IntToStr(Index)]);
    TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).ExecuteScript('InfoWindowSetMaxWidth', Params);

    // ES: control de errores // EN: error control
    TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).ErrorControl;

    // ES/EN: evento/event
    if Assigned(TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).OnMaxWidthChange) then
      TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).OnMaxWidthChange(TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent), Index, Self);
  end;
end;

procedure TLinkedComponent.OnPixelOffsetChange(Sender: TObject);
const
  StrParams = '%s,%s,%s,%s';
var
  Params: string;
begin
  if Assigned(Collection) and (Collection is TLinkedComponents) and
     Assigned(TLinkedComponents(Collection).FGMLinkedComponent) and
     TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).AutoUpdate then
  begin
    Params := Format(StrParams, [
                      IntToStr(FIdxList),
                      IntToStr(FInfoWindow.PixelOffset.Height),
                      IntToStr(FInfoWindow.PixelOffset.Width),
                      IntToStr(Index)]);
    TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).ExecuteScript('InfoWindowSetPixelOffset', Params);

    // ES: control de errores // EN: error control
    TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).ErrorControl;

    // ES/EN: evento/event
    if Assigned(TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).OnPixelOffsetChange) then
      TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).OnPixelOffsetChange(TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent), Index, Self);
  end;
end;

procedure TLinkedComponent.SetIdxList(const Value: Cardinal);
begin
  if FIdxList = Value then Exit;

  FIdxList := Value;
end;

end.
