unit GMSize;

interface

uses
  Classes;

type
  { ****************************************************************************
    https://developers.google.com/maps/documentation/javascript/reference#Size
  **************************************************************************** }
  TGMSize = class(TPersistent)
  private
    FWidth: Integer;
    FHeight: Integer;
  protected
    procedure SetHeight(const Value: Integer); virtual;
    procedure SetWidth(const Value: Integer); virtual;
  public
    constructor Create; virtual;
  published
    property Height: Integer read FHeight write SetHeight;
    property Width: Integer read FWidth write SetWidth;
  end;

implementation

{ TGMSize }

constructor TGMSize.Create;
begin
  FWidth := 0;
  FHeight := 0;
end;

procedure TGMSize.SetHeight(const Value: Integer);
begin
  if FHeight = Value then Exit;

  FHeight := Value;
end;

procedure TGMSize.SetWidth(const Value: Integer);
begin
  if FWidth = Value then Exit;

  FWidth := Value;
end;

end.
